 //Robo Cup  Commentater  
import java.awt.*;
import java.net.*;
import java.io.*;
import java.awt.event.*;
import java.util.*;
import java.text.*;

public class AnalyzeInfo extends ReplayInfo{

	/**************************************/
	/*              field                 */
	/**************************************/ 

	AnalyzedPlayer anaPlayer[] = new AnalyzedPlayer[22]; 
	int shihaiLeft = 0,shihaiRight=0, play_on_time = 0, play_off_time = 0;		
	int index;

	KickAnalyzer kickAna;
	Vector kabePassBuffer;
	BallPosAnalyzer bpAna;

	int offSide_l;
	int offSide_r;	
	String	logName;

	public int beforeScoreL = 0;	
	public int beforeScoreR = 0;	
	
	boolean num5 = false;

  	AnalyzeInfo(String logName){

		super();
		
		this.logName = logName;	

		kickAna = new KickAnalyzer(this);
		bpAna = new BallPosAnalyzer(this);

	}

  public void initAnalyzedPlayer(){
  
    for(int i = 0; i <= 21; ++i){

	anaPlayer[i] = new AnalyzedPlayer(player[i], this);	    
    }


  }

    public void setPlayerPosition(Formation form){

	for(int i = 0; i<= 10; i++){

	    anaPlayer[i].setPosition(form.getFormationLocation(i));

	}

    }

   public void addObserverPlayer(Formation form){

	for (int i = 0; i <= 10; i++){

		form.addObserver(anaPlayer[i]);
		
	}
	
   }

	void drawAll(Graphics g){

	 /*   	    
		for (int i = 0; i <= 10; ++i){
		
			anaPlayer[i].drawMigration(g);

		}
	*/
		for (int i = 0; i <= 10; ++i){
		
				anaPlayer[i].drawPlayer(g);

			}
	
		for (int i = 11; i <= 21; ++i){
		
			anaPlayer[i].drawEnemyPlayer(g);

		}


		for (int i = 0; i <= 21; ++i){
			
			player[i].drawPlayer(g);
		}	
		
		cball.drawBall(g);
	}

	public void drawFormation(Graphics g){

	    for (int i = 0; i <= 10; ++i){
		
		anaPlayer[i].drawPlayer(g);

	    }
		
	}

	public void analyze(){

		kickAna.analyze();
		bpAna.analyze();

			
	}

        public double getBallAverageY(int startTime, int endTime){

                double  totalPosy = 0;
                double  heikiny = 0;

                for(int j = startTime ;j <= endTime; j++){

                        totalPosy += cball.arrayy[j];
                }

                heikiny = totalPosy/(endTime -startTime + 1);
	

		return heikiny;

	}

	public double getBallVarienceY(int startTime, int endTime){

        	double  totalPosy = 0;
        	double  heikiny = 0;
	        double  tempy = 0;

        	for(int j = startTime ;j <= endTime; j++){
        
            		totalPosy += cball.arrayy[j];
       		}

        	heikiny = totalPosy/(endTime -startTime + 1);

        	for(int j = 0 ;j <= endTime - startTime + 1;j++){

            		tempy += Math.pow(heikiny - cball.arrayy[j],2);
                 
		}        
         
         double bunsanY = Math.sqrt(tempy/(CParam.END_TIME - CParam.START_TIME + 1));

	 return bunsanY;	


	}

	protected double calcAverage(double array[], int from, int to){
	 
		double total = 0.0;

		for(int i = from; i <= to; i++){

			total += array[i];			

		}
		
		return (total / (to - from + 1));

	}

	protected double calcVarience(double array[], double average, int from, int to){ 
		
		double temp = 0.0;
	
		for(int i = from; i <= to; i++){
			temp += Math.pow(average - array[i] , 2);	
		}	
	
		return Math.sqrt(temp / (to- from + 1));		

	}
}

 




