// Cup  Commentater  
import java.awt.*;
import java.net.*;
import java.io.*;
import java.awt.event.*;
import java.util.*;
//
//
//
class CPort extends Thread {

	/*********************************/
	/*           field               */
	/*********************************/

	boolean saidFlag = false;

	String pmod;

	MainWindow mw ;

	ReadLogFile readlf;	
	ShowInfo sInfo;
	AnalyzeInfo aInfo;

	CoachBrain cBrain;

	static boolean myTeamIsLeft = true;
	
	String host = null;
	int port = 0;

	long thisTime, beforeTime;
	
	int waitTime;

	int x, y, angle, side, unum, enable; 
	Color c;

	String MyTeamName;

        public CPort(String host, int port, String MyTeamName){


                this.host = host;
                this.port = port;
                this.MyTeamName = MyTeamName;
          
                sInfo = new ShowInfo();
                aInfo = new AnalyzeInfo(host);
                cBrain = new CoachBrain(mw, aInfo, this);

                Thread.yield();
        
                //connecting soccer server
                open();
                
                init();
        }

	public CPort(MainWindow mw, String host, int port, String MyTeamName){
		
		this.mw = mw;
		this.host = host;
		this.port = port;
		this.MyTeamName = MyTeamName;

		sInfo = new ShowInfo();		
		aInfo = new AnalyzeInfo(host);
		cBrain = new CoachBrain(mw, aInfo, this);		
                
                //֥СؤϿ
                cBrain.form.addObserver(mw.eastPanel);
                cBrain.form.addObserver(mw.getCField());

		Thread.yield();

		//connecting soccer server
		open();

		init();

		mw.getCField().createGraphicsBuffer();
                mw.getCField().drawFormation(cBrain.form);
	}	

	protected  void open(){
		
		readlf = new ReceiveInfo(host, port, MyTeamName, this);
		readlf.open();	
		
	}
	
	public void close(){
		
		cBrain.close();

	}

	public void init(){

		ReceiveInfo ri = (ReceiveInfo)readlf;

		try{

			ri.init();

		}catch(IOException e){
				
			e.printStackTrace();		

		}
		
		Thread.yield();

		System.out.println("this is cport init "+CParam.isMyTeamLeft);

		aInfo.initAnalyzedPlayer();
                aInfo.addObserverPlayer(cBrain.form);


	}

	public void send_info(String msg) {
	
		ReceiveInfo ri;
		
		ri = (ReceiveInfo)readlf;		

		boolean a = ri.send_info(msg);		

	}
	
	protected void sInfo2rInfo(){

			aInfo.kicked = false;
			aInfo.kickMember = 100;
			
			//򥻥å
			aInfo.setTime(sInfo.getTime());	
			
			//ץ쥤⡼ɤ򥻥å
			//ɲäν
			
			pmod = sInfo.getPlayMode();

			if ((pmod.equals("kick_off_l")) || (pmod.equals("kick_off_r"))){

				aInfo.setPlayMode("play_on");			

			}else{

				aInfo.setPlayMode(pmod);

			}


			for(int i = 0; i < 2; ++i){
				//򥻥å	
				aInfo.setScore(i, sInfo.getScore(i));
				//̾򥻥å
				aInfo.setTeamName(i, sInfo.getTeamName(i));
			}
		
			//ܡκɸ򥻥å		
			aInfo.setCBall(sInfo.getX(0), sInfo.getY(0));
			
			//ץ졼䡼κɸ򥻥å
					
			for (int i = 1; i <= 22; ++i){

				if (sInfo.getEnable(i) != 0){

					x = sInfo.getX(i);
					y = sInfo.getY(i);
					angle = sInfo.getAngle(i);
					side = sInfo.getSide(i);
					unum = sInfo.getUnum(i);
					enable = sInfo.getEnable(i);

					aInfo.setPlayer(i-1, x, y, angle, side, unum, (side == (int)CParam.CType_LEFT ) ? CParam.TEAM_L_COLOR: CParam.TEAM_R_COLOR, enable);
	

			}


		}			
		
	}

	public void run(){
						
		//System.out.println("started run();");

		String playMode;

		long baseTime, sleepTime;

		baseTime = System.currentTimeMillis();


		while(true){		
			
			sInfo = readlf.getShowInfo();

			if (sInfo != null){  
		
				sInfo2rInfo();

				playMode = aInfo.getPlayMode();

				aInfo.analyze();
	
				//ץ쥤⡼ɤȥץ졼ˤʤä顢
				//playerإå
				
				if(playMode.equals("play_on")){

					saidFlag = false;

				}else if (saidFlag == false){

					saidFlag = true;

					if(cBrain.think()){
										
                                        	for(int i = 3; i >= 1; i--){

                                                	cBrain.say(i);
						
				                        sleepTime = 100 -
                          				((System.currentTimeMillis()-baseTime)%100);

							try{
        	                        			sleep(sleepTime);
                	        			}
                        				catch(InterruptedException e){
								e.printStackTrace();	
							} 
		                                }                
                                        }
				}

			
				aInfo.changes();

			}

			//wait for one step
                        sleepTime = 100 - 
                          ((System.currentTimeMillis()-baseTime)%100);

			
			try{

				sleep(sleepTime);
			}
			catch(InterruptedException e){
			
				e.printStackTrace();

			}

		} 

	}

}


