//
import java.util.*;
//
//
//
public class LandMark {

	/***********************************/
	/*             field               */
	/***********************************/ 

	static Hashtable ht;	



        /***********************************/
        /*          constructor            */
        /***********************************/

	public LandMark(){
		
		ht = new Hashtable();

		//center mark
		ht.put("flag c", new DPoint(0,0));
		ht.put("flag c t", new DPoint(0, -SoccerLib.pitch_w / 2));
		ht.put("flag c b", new DPoint(0,  SoccerLib.pitch_w / 2));		
		//goal
		ht.put("goal l", new DPoint(-SoccerLib.pitch_l / 2, 0));
		ht.put("goal r", new DPoint( SoccerLib.pitch_l / 2, 0));

		//goal posts
		ht.put("flag g l t", new DPoint(-SoccerLib.pitch_l / 2, - SoccerLib.goal_s / 2));
		ht.put("flag g l b", new DPoint(-SoccerLib.pitch_l / 2,   SoccerLib.goal_s / 2));
		ht.put("flag g r t", new DPoint( SoccerLib.pitch_l / 2, - SoccerLib.goal_s / 2));
		ht.put("flag g r b", new DPoint( SoccerLib.pitch_l / 2,   SoccerLib.goal_s / 2));

		//penalty mark
		ht.put("flag p l t", new DPoint( -SoccerLib.pena_x,  -SoccerLib.pena_y));
		ht.put("flag p l c", new DPoint( -SoccerLib.pena_x,  0                ));
		ht.put("flag p l b", new DPoint( -SoccerLib.pena_x,   SoccerLib.pena_y));
		ht.put("flag p r t", new DPoint(  SoccerLib.pena_x,  -SoccerLib.pena_y));
		ht.put("flag p r c", new DPoint(  SoccerLib.pena_x,  0                ));
		ht.put("flag p r b", new DPoint(  SoccerLib.pena_x,   SoccerLib.pena_y));

		//corner mark
		ht.put("flag l t", new DPoint(-SoccerLib.pitch_l / 2, -SoccerLib.pitch_w / 2));
		ht.put("flag l b", new DPoint(-SoccerLib.pitch_l / 2, SoccerLib.pitch_w / 2));
		ht.put("flag r t", new DPoint(SoccerLib.pitch_l / 2, -SoccerLib.pitch_w / 2));
		ht.put("flag r b", new DPoint(SoccerLib.pitch_l / 2, SoccerLib.pitch_w / 2));

		//flags of outside of the pitch

		ht.put("flag l 0", new DPoint(-SoccerLib.pitch_l / 2 - 5, 0));
		ht.put("flag r 0", new DPoint(SoccerLib.pitch_l / 2 + 5, 0));
		ht.put("flag t 0", new DPoint(0, -SoccerLib.pitch_w / 2 - 5));
		ht.put("flag b 0", new DPoint(0, SoccerLib.pitch_w / 2 + 5));

		for(int x = 1; x <= 5; x ++){

			ht.put("flag t l "+new Integer(x).toString(), new DPoint( (double)-x, -SoccerLib.pitch_w / 2 - 5));
			ht.put("flag t r "+new Integer(x).toString(), new DPoint( (double)x, -SoccerLib.pitch_w / 2 - 5)); 
			ht.put("flag b l "+new Integer(x).toString(), new DPoint( (double)-x, SoccerLib.pitch_w / 2 + 5));
			ht.put("flag b r "+new Integer(x).toString(), new DPoint( (double)x, SoccerLib.pitch_w / 2 + 5));	

		}

		 for(int y = 1; y <= 3; y ++){

                        ht.put("flag l t "+new Integer(y).toString(), new DPoint(-SoccerLib.pitch_l / 2 - 5, (double)-y ));
                        ht.put("flag l b "+new Integer(y).toString(), new DPoint(-SoccerLib.pitch_l / 2 - 5, (double)y  )); 
                        ht.put("flag r t "+new Integer(y).toString(), new DPoint(SoccerLib.pitch_l / 2 + 5 , (double)-y ));
                        ht.put("flag r b "+new Integer(y).toString(), new DPoint(SoccerLib.pitch_l / 2 + 5 , (double)y  )); 
                 
                }

	}

	public DPoint get(String st){

		return (DPoint)(ht.get(st.trim()));	
	
	}

}






